<template>
  <div class="booking-form">
    <template v-if="restaurant.allowBooking">
      <div class="lg-flex lg-flex-gutter">
        <div class="form-group flex-1">
          <label class="form-label">{{ $t("filters.numOfPersons") }}</label>
          <div class="picker-control-wrapper adult-size-picker">
            <select v-model.number="validGroupSize" class="picker-control">
              <option v-for="n in adultGroupSizes" :value="n">{{
                $t("bookingForm.nAdult", { n })
              }}</option>
            </select>
          </div>

          <div
            class="picker-control-wrapper"
            v-if="!restaurant.webKidsSelectorHidden"
          >
            <select v-model.number="numberOfKidChairs" class="picker-control">
              <option value="0">{{ $t("bookingForm.nKid", { n: 0 }) }}</option>
              <option
                v-for="n in restaurant.maxBookingGroupSize - validGroupSize"
                :value="n"
                >{{ $t("bookingForm.nKid", { n }) }}</option
              >
            </select>
          </div>

          <small class="form-text text-muted">{{
            $t("bookingForm.sizeLimitHint", {
              size: restaurant.maxBookingGroupSize
            })
          }}</small>
        </div>

        <div class="form-group flex-1">
          <label class="form-label">{{ $t("filters.date") }}</label>
          <input
            id="calendar-toggle"
            v-model="calendarToggle"
            class="d-none"
            type="checkbox"
          />
          <div
            class="picker-control-wrapper picker-control-wrapper--datepicker"
          >
            <label for="calendar-toggle" class="picker-control">
              {{ date | displayDate }}
            </label>
          </div>
          <div id="calendar-box">
            <div id="calendar-wrapper">
              <date-picker
                :locale="$i18n.locale"
                :activeDate="activeDate"
                v-model="date"
              />
            </div>
          </div>
        </div>
      </div>

      <div class="form-group" v-if="!loading">
        <template v-if="slots.length">
          <input
            v-for="s in strategies"
            :id="`strategy-${s}`"
            class="d-none"
            type="radio"
            :value="s"
            v-model="strategy"
          />
          <div class="strategy-list-container">
            <div ref="strategyList" id="strategy-list" class="content-small">
              <div
                :id="`strategy-${s}-toggle`"
                @click="selectStrategy(s, i)"
                v-for="(s, i) in strategies"
                class="strategy-item pointer"
              >
                {{ $t(`filters.strategies.${s}`) }}
                <span class="strategy-session">{{
                  sessionTimeMappings[s] &&
                    Object.values(sessionTimeMappings[s]).join("-")
                }}</span>
              </div>
            </div>
          </div>

          <p v-if="!displaySlots.length" class="sorry-box">
            {{ $t("sorry.noSlot") }}
          </p>

          <div class="flex slot-list">
            <div
              class="slot-item"
              :key="slot.time"
              v-for="slot in displaySlots"
              :class="{
                'slot-item--active': time == slot.time,
                'slot-item--disabled': !slot.active
              }"
            >
              <button @click="selectTime(slot)" class="slot-btn">
                {{ slot.time }}
              </button>
            </div>
          </div>
        </template>
        <template v-else>
          <p class="sorry-box">{{ $t("sorry.noSlotAllDay") }}</p>
        </template>
      </div>
      <!-- Loading -->
      <div class="loading" v-else>
        <div class="flex flex-column align-items-center">
          <p class="lp md"></p>
          <p class="lp lg"></p>
        </div>
      </div>

      <div
        class="form-actions text-center mb-0"
        v-if="paramsAllPresent && isLogin"
      >
        <router-link :to="bookingPageLink" class="skm-btn skm-primary-btn">{{
          $t("actions.book")
        }}</router-link>
      </div>

      <template v-if="paramsAllPresent && !isLogin">
        <button
          class="request-login-button"
          @click.prevent.stop="
            startLogin(['callRouterMethod', 'push', bookingPageLink])
          "
        >
          <login-banner />
        </button>
      </template>
    </template>
    <template v-else>
      <div class="info-wrapper">
        <div
          class="info-board flex flex-column align-items-center justify-content-center text-center"
        >
          <div
            v-html="$t('restaurant.notAllowBooking')"
            class="info-title title-lg c-pigeon-grey"
          ></div>
        </div>
      </div>
    </template>
  </div>
</template>
<script>
import { mapState, mapActions, mapGetters } from "vuex";
import DatePicker from "@/components/DatePicker";
import moment from "moment";
import _ from "underscore";
import Branch from "@/api/branch";
import Restaurant from "@/models/restaurant";
import sessionTimeMappings from "@/const/sessionTimeMappings";
import { isTimeBetween } from "@/utils";
import LoginBanner from "@/components/LoginBanner";

const bookingSessionTimeMappings = _.omit(sessionTimeMappings, "waiting");

export default {
  components: {
    DatePicker,
    LoginBanner
  },
  data() {
    const {
      groupSize,
      numberOfKidChairs,
      date,
      time,
      from
    } = this.$route.query;

    return {
      sessionTimeMappings,
      date: date || moment().format("YYYY-MM-DD"),
      time,
      strategy: null,
      groupSize: Number(groupSize) || 2,
      numberOfKidChairs: numberOfKidChairs || 0,
      calendarToggle: false,
      from,
      vipSlot: false
    };
  },
  computed: {
    ...mapState(["locale"]),
    ...mapState("restaurant", ["restaurant", "loading"]),
    ...mapGetters("account", ["isLogin", "isVipMember"]),
    validGroupSize: {
      get() {
        return Math.max(
          Math.min(this.groupSize, this.restaurant.maxBookingGroupSize),
          this.restaurant.minBookingGroupSize
        );
      },
      set(val) {
        this.groupSize = val;
      }
    },
    adultGroupSizes() {
      const sizes = [];
      for (
        let i = this.restaurant.minBookingGroupSize;
        i <= this.restaurant.maxBookingGroupSize;
        i++
      ) {
        if (i - this.numberOfKidChairs > 0) {
          sizes.push(i - this.numberOfKidChairs);
        }
      }
      return sizes;
    },
    sessionTime() {
      return this.sessionTimeMappings[this.strategy] || {};
    },
    displaySlots() {
      const { from, to } = this.sessionTime;
      return this.slots.filter(slot => isTimeBetween(slot.time, from, to));
    },
    dateAndSize() {
      return `${this.date}|${this.validGroupSize}|${this.numberOfKidChairs}`;
    },
    paramsAllPresent() {
      return [this.validGroupSize, this.date, this.time].all(p => p);
    },
    size() {
      return this.validGroupSize + this.numberOfKidChairs;
    },
    strategies() {
      return this.isVipMember
        ? this.restaurant.vipAvailableBookingStrategies
        : this.restaurant.availableBookingStrategies;
    },
    slots() {
      return this.isVipMember
        ? this.restaurant.vipSlots
        : this.restaurant.slots;
    },
    bookingPageLink() {
      return {
        name: "NewReservation",
        query: {
          groupSize: this.validGroupSize,
          date: this.date,
          time: this.time,
          numberOfKidChairs: this.numberOfKidChairs,
          vipSlot: this.vipSlot ? 1 : 0
        }
      };
    },
    activeDate() {
      return this.isVipMember
        ? this.restaurant.availableDate()
        : this.restaurant.vipAvailableDate();
    }
  },
  watch: {
    date() {
      this.calendarToggle = false;
    },
    restaurant() {
      this.validateSelectedDate();
    },
    dateAndSize() {
      this.fetchSlots().then(() => {
        this.strategy = this.findDefaultStrategy(this.time);
        if (!this.slots.length) {
          this.time = null;
        }
        if (this.displaySlots.every(p => !p.active)) {
          this.time = null;
        }
        this.calendarToggle = !this.hasActiveSlots();
      });
    }
  },
  methods: {
    ...mapActions("account", ["startLogin"]),
    validateSelectedDate() {
      if (!this.activeDate[this.date]) {
        this.date = Object.keys(this.activeDate)[0];
      }
    },
    findDefaultStrategy(time) {
      // TODO: refactor
      if (!time) {
        if (this.strategies && this.strategies.length) {
          return this.strategies[0];
        } else {
          return Object.keys(bookingSessionTimeMappings)[0];
        }
      }
      const match = Object.entries(bookingSessionTimeMappings).find(([s, t]) =>
        isTimeBetween(time, t.from, t.to)
      );
      return match[0];
    },
    selectStrategy(strategy, index) {
      this.strategy = strategy;
    },
    fetchSlots() {
      const { groupId, companyId, id } = this.restaurant;
      const { size, date } = this;

      return this.$store.dispatch("restaurant/fetchRestaurant", {
        groupId,
        companyId,
        id,
        params: { size, date, type: "all", language: this.locale }
      });
    },
    hasActiveSlots() {
      return this.displaySlots.reduce(
        (result, slot) => result || slot.active,
        false
      );
    },
    selectTime(slot) {
      this.time = slot.time;
      this.vipSlot = slot.vipSlot;
    }
  },
  mounted() {
    this.validateSelectedDate();
    this.strategy = this.findDefaultStrategy(this.time);
    this.calendarToggle = !this.hasActiveSlots();
    window.gtag("event", `pageview`, {
      event_category: "美食地圖餐廳訂位",
      event_label: JSON.stringify({
        category: [
          this.restaurant.groupName,
          this.restaurant.buildingName,
          this.restaurant.floor
        ].join(" - "),
        value: this.restaurant.company.name,
        content: `${this.validGroupSize}位大人」 ${this.numberOfKidChairs}位小孩`,
        time: this.date + " " + this.time
      })
    });
    if (this.from === "slot") {
      if (this.isLogin) {
        this.$router.push(this.bookingPageLink);
      } else {
        this.startLogin({
          finishAction: ["callRouterMethod", "push", this.bookingPageLink]
        });
      }
    }
  }
};
</script>
<style lang="scss" scoped>
$strategy-list: bookingNoon bookingAfternoon bookingNight;

@include radio-connect("strategy", $strategy-list) {
  color: $color-skm-red;
  border-bottom-color: rgba($color-skm-red, 1);
  font-weight: 500;

  .strategy-session {
    display: inline;
  }
}

.strategy-list-container {
  height: 50px;
  overflow: hidden;
  border-bottom: 1px solid $color-silver-grey;
  margin-bottom: 20px;
  @include media-breakpoint-up(md) {
    height: 56px;
  }
}

#strategy-list {
  white-space: nowrap;
  color: $color-secondary-black;
  height: 80px;
  display: flex;
  flex-direction: row;
  overflow-x: scroll;
  overflow-y: hidden;
  -webkit-overflow-scrolling: touch;

  @include media-breakpoint-up(md) {
    height: 86px;
    font-size: 18px;
    margin-bottom: 30px;
  }
}

.strategy-item {
  border-bottom: 33px solid rgba($color-skm-red, 0);
  transition: border-color 0.3s, color 0.3s;
  padding: 13px 0;
  height: 80px;
  & + & {
    margin-left: $grid-gutter-width * 1.5;
  }

  @include media-breakpoint-up(md) {
    height: 86px;
    & + & {
      margin-left: $grid-gutter-width * 2.5;
    }
  }
}

.strategy-session {
  display: none;
}

.booking-form {
  padding: $grid-gutter-width $grid-gutter-width/2 0 $grid-gutter-width/2;
  @include media-breakpoint-up(md) {
    padding: $grid-gutter-width $grid-gutter-width * 2 $grid-gutter-width * 1.5
      $grid-gutter-width * 2;
  }
  @include media-breakpoint-up(lg) {
    padding: $grid-gutter-width $grid-gutter-width * 4 $grid-gutter-width * 1.5
      $grid-gutter-width * 4;
  }
}

#calendar-box {
  overflow: hidden;
  max-height: 0;
  transition: max-height 0.8s;
}

#calendar-wrapper {
  border: 1px solid $color-sky-grey;
  border-radius: 4px;
  margin-top: 0.5em;
}

#calendar-toggle:checked {
  & ~ #calendar-box {
    max-height: 400px;
  }

  & ~ .picker-control-wrapper--datepicker {
    &:after {
      color: $color-white;
      transform: translateY(-50%) rotate(180deg);
    }

    [for="calendar-toggle"] {
      background-color: $color-skm-red;
      color: $color-white;
    }
  }
}

.slot-list {
  flex-flow: row wrap;
  margin: 0 -5px;

  @include media-breakpoint-up(md) {
    margin: 0 -8px;
  }
}

.slot-item {
  flex: 0 1 25%;
  padding: 0 5px 10px 5px;

  @include media-breakpoint-up(md) {
    flex: 0 1 20%;
    padding: 0 8px 16px 8px;
  }
  @include media-breakpoint-up(lg) {
    flex: 0 1 16.66%;
  }
}

.slot-btn {
  border-radius: 2px;
  border: 1px solid $color-silver-grey;
  color: $color-secondary-black;
  line-height: 36px;
  appearance: none;
  padding: 0;
  display: block;
  background-color: $color-white;
  width: 100%;
  cursor: pointer;

  .slot-item--active & {
    background-color: $color-skm-red;
    border-color: $color-skm-red;
    color: $color-white;
  }

  .slot-item--disabled & {
    pointer-events: none;
    border-color: $color-mineral-ice;
    background-color: $color-mineral-ice;
    color: $color-silver-grey;
  }

  @include media-breakpoint-up(md) {
    line-height: 40px;
  }
}

.adult-size-picker {
  margin-bottom: 0.75em;
}

.request-login-button {
  margin: 0;
  padding: 0;
  background: none;
  border: none;
  cursor: pointer;
  width: 100%;
  text-align: center;
}
</style>
